Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/CRS/crsdom.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/CRS/crsdom.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/CRS/crsdom.F90	(revision 14644)
@@ -30,5 +30,5 @@
    !!       Original.   May 2012.  (J. Simeon, C. Calone, G. Madec, C. Ethe)
    !!===================================================================
-   USE dom_oce        ! ocean space and time domain and to get jperio
+   USE dom_oce        ! ocean space and time domain
    USE crs            ! domain for coarse grid
    !
@@ -1877,183 +1877,183 @@
  
   
-     ! 1.a. Define global domain indices  : take into account the interior domain only ( removes i/j=1 , i/j=jpiglo/jpjglo ) then add 2/3 grid points 
-      jpiglo_crs   = INT( (jpiglo - 2) / nn_factx ) + 2
-  !    jpjglo_crs   = INT( (jpjglo - 2) / nn_facty ) + 2  ! the -2 removes j=1, j=jpj
-  !    jpjglo_crs   = INT( (jpjglo - 2) / nn_facty ) + 3
-      jpjglo_crs   = INT( (jpjglo - MOD(jpjglo, nn_facty)) / nn_facty ) + 3
-      jpiglo_crsm1 = jpiglo_crs - 1
-      jpjglo_crsm1 = jpjglo_crs - 1  
-
-      jpi_crs = ( jpiglo_crs   - 2 * nn_hls + (jpni-1) ) / jpni + 2 * nn_hls
-      jpj_crs = ( jpjglo_crsm1 - 2 * nn_hls + (jpnj-1) ) / jpnj + 2 * nn_hls   
-              
-      IF( noso < 0 ) jpj_crs = jpj_crs + 1    ! add a local band on southern processors  
-       
-      jpi_crsm1   = jpi_crs - 1
-      jpj_crsm1   = jpj_crs - 1
-      nperio_crs  = jperio
-      npolj_crs   = npolj
-      
-      ierr = crs_dom_alloc()          ! allocate most coarse grid arrays
-
-      ! 2.a Define processor domain
-      IF( .NOT. lk_mpp ) THEN
-         nimpp_crs = 1
-         njmpp_crs = 1
-         Nis0_crs  = 1
-         Njs0_crs  = 1
-         Nie0_crs  = jpi_crs
-         Nje0_crs  = jpj_crs
-      ELSE
-         ! Initialisation of most local variables -
-         nimpp_crs = 1
-         njmpp_crs = 1
-         Nis0_crs  = 1
-         Njs0_crs  = 1
-         Nie0_crs  = jpi_crs
-         Nje0_crs  = jpj_crs
-         
-        ! Calculs suivant une découpage en j
-        DO jn = 1, jpnij, jpni
-           IF( jn < ( jpnij - jpni + 1 ) ) THEN
-              nje0all_crs(jn) = AINT( REAL( ( jpjglo - (njmppt(jn     ) - 1) ) / nn_facty, wp ) ) &
-                       &    - AINT( REAL( ( jpjglo - (njmppt(jn+jpni) - 1) ) / nn_facty, wp ) )
-           ELSE                                             
-              nje0all_crs(jn) = AINT( REAL(  nje0all(jn) / nn_facty, wp ) ) + 1            
-           ENDIF
-           IF( noso < 0 ) nje0all_crs(jn) = nje0all_crs(jn) + 1             
-           SELECT CASE( ibonjt(jn) )
-              CASE ( -1 )
-                IF( MOD( jpjglo - njmppt(jn), nn_facty) > 0 )  nje0all_crs(jn) = nje0all_crs(jn) + 1
-                jpjall_crs (jn) = nje0all_crs(jn) + nn_hls
-                njs0all_crs(jn) = njs0all(jn)
-              
-              CASE ( 0 )
-              
-                njs0all_crs(jn) = njs0all(jn)
-                IF( njs0all(jn) == 1 )  nje0all_crs(jn) = nje0all_crs(jn) + 1
-                nje0all_crs(jn) = nje0all_crs(jn) + nn_hls
-                jpjall_crs (jn) = nje0all_crs(jn) + nn_hls
-                
-              CASE ( 1, 2 )
-              
-                nje0all_crs(jn) = nje0all_crs(jn) + nn_hls
-                jpjall_crs (jn) = nje0all_crs(jn)
-                njs0all_crs(jn) = njs0all(jn)
-                
-              CASE DEFAULT
-                 CALL ctl_stop( 'STOP', 'error from crs_dom_def, you should not be there (1) ...' )
-           END SELECT
-           IF( jpjall_crs(jn) > jpj_crs )     jpj_crs = jpj_crs + 1
-
-           IF(njs0all_crs(jn) == 1 ) THEN
-              njmppt_crs(jn) = 1
-           ELSE
-              njmppt_crs(jn) = 2 + ANINT(REAL((njmppt(jn) + 1 - MOD( jpjglo , nn_facty )) / nn_facty, wp ) )
-           ENDIF           
-           
-           DO jj = jn + 1, jn + jpni - 1
-              nje0all_crs(jj) = nje0all_crs(jn) 
-              jpjall_crs (jj) = jpjall_crs(jn)
-              njs0all_crs(jj) = njs0all_crs(jn)
-              njmppt_crs (jj) = njmppt_crs(jn)
-           ENDDO
-        ENDDO 
-        Nje0_crs  = nje0all_crs(nproc + 1) 
-        jpj_crs   = jpjall_crs (nproc + 1)
-        Njs0_crs  = njs0all_crs(nproc + 1)
-        njmpp_crs = njmppt_crs (nproc + 1)
-
-        ! Calcul suivant un decoupage en i
-        DO jn = 1, jpni
-           IF( jn == 1 ) THEN          
-              nie0all_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + jpiall(jn  ) )  / nn_factx, wp) )
-           ELSE
-              nie0all_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + jpiall(jn  ) )  / nn_factx, wp) ) &
-                 &            - AINT( REAL( ( nimppt(jn-1) - 1 + jpiall(jn-1) )  / nn_factx, wp) )
-           ENDIF
-
-           SELECT CASE( ibonit(jn) )
-              CASE ( -1 )
-                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls           
-                 jpiall_crs (jn) = nie0all_crs(jn) + nn_hls
-                 nis0all_crs(jn) = nis0all(jn) 
-              
-              CASE ( 0 )
-                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls
-                 jpiall_crs (jn) = nie0all_crs(jn) + nn_hls
-                 nis0all_crs(jn) = nis0all(jn) 
-                
-              CASE ( 1, 2 )
-                 IF( MOD( jpiglo - nimppt(jn), nn_factx) > 0 )  nie0all_crs(jn) = nie0all_crs(jn) + 1
-                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls
-                 jpiall_crs (jn) = nie0all_crs(jn)
-                 nis0all_crs(jn) = nis0all(jn) 
-
-              CASE DEFAULT
-                 CALL ctl_stop( 'STOP', 'error from crs_dom_def, you should not be there (2) ...' )
-           END SELECT
-
-           nimppt_crs(jn) = ANINT( REAL( (nimppt(jn) + 1 ) / nn_factx, wp ) ) + 1
-           DO jj = jn + jpni , jpnij, jpni
-              nie0all_crs(jj) = nie0all_crs(jn) 
-              jpiall_crs (jj) = jpiall_crs (jn)
-              nis0all_crs(jj) = nis0all_crs(jn)
-              nimppt_crs (jj) = nimppt_crs (jn)
-           ENDDO
-         ENDDO 
-        
-         Nie0_crs  = nie0all_crs(nproc + 1) 
-         jpi_crs   = jpiall_crs (nproc + 1)
-         Nis0_crs  = nis0all_crs(nproc + 1)
-         nimpp_crs = nimppt_crs (nproc + 1)
-
-         DO ji = 1, jpi_crs
-            mig_crs(ji) = ji + nimpp_crs - 1
-         ENDDO
-         DO jj = 1, jpj_crs
-            mjg_crs(jj) = jj + njmpp_crs - 1!
-         ENDDO
-       
-         DO ji = 1, jpiglo_crs
-            mi0_crs(ji) = MAX( 1, MIN( ji - nimpp_crs + 1 , jpi_crs + 1 ) )
-            mi1_crs(ji) = MAX( 0, MIN( ji - nimpp_crs + 1 , jpi_crs     ) )
-         ENDDO
-         
-         DO jj = 1, jpjglo_crs
-            mj0_crs(jj) = MAX( 1, MIN( jj - njmpp_crs + 1 , jpj_crs + 1 ) )
-            mj1_crs(jj) = MAX( 0, MIN( jj - njmpp_crs + 1 , jpj_crs     ) )
-         ENDDO
-
-      ENDIF
-      
-      !                         Save the parent grid information
-      jpi_full    = jpi
-      jpj_full    = jpj
-      jpim1_full  = jpim1
-      jpjm1_full  = jpjm1
-      nperio_full = jperio
-
-      npolj_full  = npolj
-      jpiglo_full = jpiglo
-      jpjglo_full = jpjglo
-
-      jpj_full   = jpj
-      jpi_full   = jpi
-      Nis0_full  = Nis0
-      Njs0_full  = Njs0
-      Nie0_full  = Nie0
-      Nje0_full  = Nje0
-      nimpp_full = nimpp     
-      njmpp_full = njmpp
-      
-      jpiall_full (:) = jpiall (:)
-      nis0all_full(:) = nis0all(:)
-      nie0all_full(:) = nie0all(:)
-      nimppt_full (:) = nimppt (:)
-      jpjall_full (:) = jpjall (:)
-      njs0all_full(:) = njs0all(:)
-      nje0all_full(:) = nje0all(:)
-      njmppt_full (:) = njmppt (:)
+!!$     ! 1.a. Define global domain indices  : take into account the interior domain only ( removes i/j=1 , i/j=jpiglo/jpjglo ) then add 2/3 grid points 
+!!$      jpiglo_crs   = INT( (jpiglo - 2) / nn_factx ) + 2
+!!$  !    jpjglo_crs   = INT( (jpjglo - 2) / nn_facty ) + 2  ! the -2 removes j=1, j=jpj
+!!$  !    jpjglo_crs   = INT( (jpjglo - 2) / nn_facty ) + 3
+!!$      jpjglo_crs   = INT( (jpjglo - MOD(jpjglo, nn_facty)) / nn_facty ) + 3
+!!$      jpiglo_crsm1 = jpiglo_crs - 1
+!!$      jpjglo_crsm1 = jpjglo_crs - 1  
+!!$
+!!$      jpi_crs = ( jpiglo_crs   - 2 * nn_hls + (jpni-1) ) / jpni + 2 * nn_hls
+!!$      jpj_crs = ( jpjglo_crsm1 - 2 * nn_hls + (jpnj-1) ) / jpnj + 2 * nn_hls   
+!!$              
+!!$      IF( noso < 0 ) jpj_crs = jpj_crs + 1    ! add a local band on southern processors  
+!!$       
+!!$      jpi_crsm1   = jpi_crs - 1
+!!$      jpj_crsm1   = jpj_crs - 1
+!!$      nperio_crs  = jperio
+!!$      npolj_crs   = npolj
+!!$      
+!!$      ierr = crs_dom_alloc()          ! allocate most coarse grid arrays
+!!$
+!!$      ! 2.a Define processor domain
+!!$      IF( .NOT. lk_mpp ) THEN
+!!$         nimpp_crs = 1
+!!$         njmpp_crs = 1
+!!$         Nis0_crs  = 1
+!!$         Njs0_crs  = 1
+!!$         Nie0_crs  = jpi_crs
+!!$         Nje0_crs  = jpj_crs
+!!$      ELSE
+!!$         ! Initialisation of most local variables -
+!!$         nimpp_crs = 1
+!!$         njmpp_crs = 1
+!!$         Nis0_crs  = 1
+!!$         Njs0_crs  = 1
+!!$         Nie0_crs  = jpi_crs
+!!$         Nje0_crs  = jpj_crs
+!!$         
+!!$        ! Calculs suivant une découpage en j
+!!$        DO jn = 1, jpnij, jpni
+!!$           IF( jn < ( jpnij - jpni + 1 ) ) THEN
+!!$              nje0all_crs(jn) = AINT( REAL( ( jpjglo - (njmppt(jn     ) - 1) ) / nn_facty, wp ) ) &
+!!$                       &    - AINT( REAL( ( jpjglo - (njmppt(jn+jpni) - 1) ) / nn_facty, wp ) )
+!!$           ELSE                                             
+!!$              nje0all_crs(jn) = AINT( REAL(  nje0all(jn) / nn_facty, wp ) ) + 1            
+!!$           ENDIF
+!!$           IF( noso < 0 ) nje0all_crs(jn) = nje0all_crs(jn) + 1             
+!!$           SELECT CASE( ibonjt(jn) )
+!!$              CASE ( -1 )
+!!$                IF( MOD( jpjglo - njmppt(jn), nn_facty) > 0 )  nje0all_crs(jn) = nje0all_crs(jn) + 1
+!!$                jpjall_crs (jn) = nje0all_crs(jn) + nn_hls
+!!$                njs0all_crs(jn) = njs0all(jn)
+!!$              
+!!$              CASE ( 0 )
+!!$              
+!!$                njs0all_crs(jn) = njs0all(jn)
+!!$                IF( njs0all(jn) == 1 )  nje0all_crs(jn) = nje0all_crs(jn) + 1
+!!$                nje0all_crs(jn) = nje0all_crs(jn) + nn_hls
+!!$                jpjall_crs (jn) = nje0all_crs(jn) + nn_hls
+!!$                
+!!$              CASE ( 1, 2 )
+!!$              
+!!$                nje0all_crs(jn) = nje0all_crs(jn) + nn_hls
+!!$                jpjall_crs (jn) = nje0all_crs(jn)
+!!$                njs0all_crs(jn) = njs0all(jn)
+!!$                
+!!$              CASE DEFAULT
+!!$                 CALL ctl_stop( 'STOP', 'error from crs_dom_def, you should not be there (1) ...' )
+!!$           END SELECT
+!!$           IF( jpjall_crs(jn) > jpj_crs )     jpj_crs = jpj_crs + 1
+!!$
+!!$           IF(njs0all_crs(jn) == 1 ) THEN
+!!$              njmppt_crs(jn) = 1
+!!$           ELSE
+!!$              njmppt_crs(jn) = 2 + ANINT(REAL((njmppt(jn) + 1 - MOD( jpjglo , nn_facty )) / nn_facty, wp ) )
+!!$           ENDIF           
+!!$           
+!!$           DO jj = jn + 1, jn + jpni - 1
+!!$              nje0all_crs(jj) = nje0all_crs(jn) 
+!!$              jpjall_crs (jj) = jpjall_crs(jn)
+!!$              njs0all_crs(jj) = njs0all_crs(jn)
+!!$              njmppt_crs (jj) = njmppt_crs(jn)
+!!$           ENDDO
+!!$        ENDDO 
+!!$        Nje0_crs  = nje0all_crs(narea) 
+!!$        jpj_crs   = jpjall_crs (narea)
+!!$        Njs0_crs  = njs0all_crs(narea)
+!!$        njmpp_crs = njmppt_crs (narea)
+!!$
+!!$        ! Calcul suivant un decoupage en i
+!!$        DO jn = 1, jpni
+!!$           IF( jn == 1 ) THEN          
+!!$              nie0all_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + jpiall(jn  ) )  / nn_factx, wp) )
+!!$           ELSE
+!!$              nie0all_crs(jn) = AINT( REAL( ( nimppt(jn  ) - 1 + jpiall(jn  ) )  / nn_factx, wp) ) &
+!!$                 &            - AINT( REAL( ( nimppt(jn-1) - 1 + jpiall(jn-1) )  / nn_factx, wp) )
+!!$           ENDIF
+!!$
+!!$           SELECT CASE( ibonit(jn) )
+!!$              CASE ( -1 )
+!!$                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls           
+!!$                 jpiall_crs (jn) = nie0all_crs(jn) + nn_hls
+!!$                 nis0all_crs(jn) = nis0all(jn) 
+!!$              
+!!$              CASE ( 0 )
+!!$                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls
+!!$                 jpiall_crs (jn) = nie0all_crs(jn) + nn_hls
+!!$                 nis0all_crs(jn) = nis0all(jn) 
+!!$                
+!!$              CASE ( 1, 2 )
+!!$                 IF( MOD( jpiglo - nimppt(jn), nn_factx) > 0 )  nie0all_crs(jn) = nie0all_crs(jn) + 1
+!!$                 nie0all_crs(jn) = nie0all_crs(jn) + nn_hls
+!!$                 jpiall_crs (jn) = nie0all_crs(jn)
+!!$                 nis0all_crs(jn) = nis0all(jn) 
+!!$
+!!$              CASE DEFAULT
+!!$                 CALL ctl_stop( 'STOP', 'error from crs_dom_def, you should not be there (2) ...' )
+!!$           END SELECT
+!!$
+!!$           nimppt_crs(jn) = ANINT( REAL( (nimppt(jn) + 1 ) / nn_factx, wp ) ) + 1
+!!$           DO jj = jn + jpni , jpnij, jpni
+!!$              nie0all_crs(jj) = nie0all_crs(jn) 
+!!$              jpiall_crs (jj) = jpiall_crs (jn)
+!!$              nis0all_crs(jj) = nis0all_crs(jn)
+!!$              nimppt_crs (jj) = nimppt_crs (jn)
+!!$           ENDDO
+!!$         ENDDO 
+!!$        
+!!$         Nie0_crs  = nie0all_crs(narea) 
+!!$         jpi_crs   = jpiall_crs (narea)
+!!$         Nis0_crs  = nis0all_crs(narea)
+!!$         nimpp_crs = nimppt_crs (narea)
+!!$
+!!$         DO ji = 1, jpi_crs
+!!$            mig_crs(ji) = ji + nimpp_crs - 1
+!!$         ENDDO
+!!$         DO jj = 1, jpj_crs
+!!$            mjg_crs(jj) = jj + njmpp_crs - 1!
+!!$         ENDDO
+!!$       
+!!$         DO ji = 1, jpiglo_crs
+!!$            mi0_crs(ji) = MAX( 1, MIN( ji - nimpp_crs + 1 , jpi_crs + 1 ) )
+!!$            mi1_crs(ji) = MAX( 0, MIN( ji - nimpp_crs + 1 , jpi_crs     ) )
+!!$         ENDDO
+!!$         
+!!$         DO jj = 1, jpjglo_crs
+!!$            mj0_crs(jj) = MAX( 1, MIN( jj - njmpp_crs + 1 , jpj_crs + 1 ) )
+!!$            mj1_crs(jj) = MAX( 0, MIN( jj - njmpp_crs + 1 , jpj_crs     ) )
+!!$         ENDDO
+!!$
+!!$      ENDIF
+!!$      
+!!$      !                         Save the parent grid information
+!!$      jpi_full    = jpi
+!!$      jpj_full    = jpj
+!!$      jpim1_full  = jpim1
+!!$      jpjm1_full  = jpjm1
+!!$      nperio_full = jperio
+!!$
+!!$      npolj_full  = npolj
+!!$      jpiglo_full = jpiglo
+!!$      jpjglo_full = jpjglo
+!!$
+!!$      jpj_full   = jpj
+!!$      jpi_full   = jpi
+!!$      Nis0_full  = Nis0
+!!$      Njs0_full  = Njs0
+!!$      Nie0_full  = Nie0
+!!$      Nje0_full  = Nje0
+!!$      nimpp_full = nimpp     
+!!$      njmpp_full = njmpp
+!!$      
+!!$      jpiall_full (:) = jpiall (:)
+!!$      nis0all_full(:) = nis0all(:)
+!!$      nie0all_full(:) = nie0all(:)
+!!$      nimppt_full (:) = nimppt (:)
+!!$      jpjall_full (:) = jpjall (:)
+!!$      njs0all_full(:) = njs0all(:)
+!!$      nje0all_full(:) = nje0all(:)
+!!$      njmppt_full (:) = njmppt (:)
       
       CALL dom_grid_crs  !swich de grille
@@ -2068,5 +2068,5 @@
          WRITE(numout,*) '~~~~~~~   coarse domain local  j-dimension              jpj = ', jpj
          WRITE(numout,*)
-         WRITE(numout,*) ' nproc  = '     , nproc
+         WRITE(numout,*) ' narea  = '     , narea
          WRITE(numout,*) ' jpi    = '     , jpi
          WRITE(numout,*) ' jpj    = '     , jpj
@@ -2097,9 +2097,9 @@
       IF ( nresty == 0 ) THEN
          mybinctr = mybinctr - 1
-         IF ( jperio == 3 .OR. jperio == 4 )  nperio_crs = jperio + 2
-         IF ( jperio == 5 .OR. jperio == 6 )  nperio_crs = jperio - 2 
-
-         IF ( npolj == 3 ) npolj_crs = 5
-         IF ( npolj == 5 ) npolj_crs = 3
+!!$         IF ( jperio == 3 .OR. jperio == 4 )  nperio_crs = jperio + 2
+!!$         IF ( jperio == 5 .OR. jperio == 6 )  nperio_crs = jperio - 2 
+!!$
+!!$         IF ( npolj == 3 ) npolj_crs = 5
+!!$         IF ( npolj == 5 ) npolj_crs = 3
       ENDIF     
       
@@ -2117,64 +2117,64 @@
       CASE ( 0 ) 
 
-         SELECT CASE ( jperio )
-     
- 
-        CASE ( 0, 1, 3, 4 )    !   3, 4 : T-Pivot at North Fold
-        
-            DO ji = 2, jpiglo_crsm1
-               ijie = ( ji * nn_factx ) - nn_factx   !cc
-               ijis = ijie - nn_factx + 1
-               mis2_crs(ji) = ijis
-               mie2_crs(ji) = ijie
-            ENDDO
-            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie2_crs(jpiglo_crsm1) = jpiglo - 2  
-
-            ! Handle first the northernmost bin
-            IF ( nn_facty == 2 ) THEN   ;    ijjgloT = jpjglo - 1 
-            ELSE                        ;    ijjgloT = jpjglo
-            ENDIF
-
-            DO jj = 2, jpjglo_crs
-                ijje = ijjgloT - nn_facty * ( jj - 3 )
-                ijjs = ijje - nn_facty + 1                   
-                mjs2_crs(jpjglo_crs-jj+2) = ijjs
-                mje2_crs(jpjglo_crs-jj+2) = ijje
-            ENDDO
-
-         CASE ( 2 ) 
-            WRITE(numout,*)  'crs_init, jperio=2 not supported' 
-        
-         CASE ( 5, 6 )    ! F-pivot at North Fold
-
-            DO ji = 2, jpiglo_crsm1
-               ijie = ( ji * nn_factx ) - nn_factx 
-               ijis = ijie - nn_factx + 1
-               mis2_crs(ji) = ijis
-               mie2_crs(ji) = ijie
-            ENDDO
-            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie_crs(jpiglo_crsm1)  = jpiglo - 2 
-
-            ! Treat the northernmost bin separately.
-            jj = 2
-            ijje = jpj - nn_facty * ( jj - 2 )
-            IF ( nn_facty == 3 ) THEN   ;  ijjs = ijje - 1 
-            ELSE                        ;  ijjs = ijje - nn_facty + 1
-            ENDIF
-            mjs2_crs(jpj_crs-jj+1) = ijjs
-            mje2_crs(jpj_crs-jj+1) = ijje
-
-            ! Now bin the rest, any remainder at the south is lumped in the southern bin
-            DO jj = 3, jpjglo_crsm1
-                ijje = jpjglo - nn_facty * ( jj - 2 )
-                ijjs = ijje - nn_facty + 1                  
-                IF ( ijjs <= nn_facty )  ijjs = 2
-                mjs2_crs(jpj_crs-jj+1)   = ijjs
-                mje2_crs(jpj_crs-jj+1)   = ijje
-            ENDDO
-
-         CASE DEFAULT
-            WRITE(numout,*) 'crs_init. Only jperio = 0, 1, 3, 4, 5, 6 supported' 
- 
-         END SELECT
+!!$         SELECT CASE ( jperio )
+!!$     
+!!$ 
+!!$        CASE ( 0, 1, 3, 4 )    !   3, 4 : T-Pivot at North Fold
+!!$        
+!!$            DO ji = 2, jpiglo_crsm1
+!!$               ijie = ( ji * nn_factx ) - nn_factx   !cc
+!!$               ijis = ijie - nn_factx + 1
+!!$               mis2_crs(ji) = ijis
+!!$               mie2_crs(ji) = ijie
+!!$            ENDDO
+!!$            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie2_crs(jpiglo_crsm1) = jpiglo - 2  
+!!$
+!!$            ! Handle first the northernmost bin
+!!$            IF ( nn_facty == 2 ) THEN   ;    ijjgloT = jpjglo - 1 
+!!$            ELSE                        ;    ijjgloT = jpjglo
+!!$            ENDIF
+!!$
+!!$            DO jj = 2, jpjglo_crs
+!!$                ijje = ijjgloT - nn_facty * ( jj - 3 )
+!!$                ijjs = ijje - nn_facty + 1                   
+!!$                mjs2_crs(jpjglo_crs-jj+2) = ijjs
+!!$                mje2_crs(jpjglo_crs-jj+2) = ijje
+!!$            ENDDO
+!!$
+!!$         CASE ( 2 ) 
+!!$            WRITE(numout,*)  'crs_init, jperio=2 not supported' 
+!!$        
+!!$         CASE ( 5, 6 )    ! F-pivot at North Fold
+!!$
+!!$            DO ji = 2, jpiglo_crsm1
+!!$               ijie = ( ji * nn_factx ) - nn_factx 
+!!$               ijis = ijie - nn_factx + 1
+!!$               mis2_crs(ji) = ijis
+!!$               mie2_crs(ji) = ijie
+!!$            ENDDO
+!!$            IF ( jpiglo - 1 - mie2_crs(jpiglo_crsm1) <= nn_factx ) mie_crs(jpiglo_crsm1)  = jpiglo - 2 
+!!$
+!!$            ! Treat the northernmost bin separately.
+!!$            jj = 2
+!!$            ijje = jpj - nn_facty * ( jj - 2 )
+!!$            IF ( nn_facty == 3 ) THEN   ;  ijjs = ijje - 1 
+!!$            ELSE                        ;  ijjs = ijje - nn_facty + 1
+!!$            ENDIF
+!!$            mjs2_crs(jpj_crs-jj+1) = ijjs
+!!$            mje2_crs(jpj_crs-jj+1) = ijje
+!!$
+!!$            ! Now bin the rest, any remainder at the south is lumped in the southern bin
+!!$            DO jj = 3, jpjglo_crsm1
+!!$                ijje = jpjglo - nn_facty * ( jj - 2 )
+!!$                ijjs = ijje - nn_facty + 1                  
+!!$                IF ( ijjs <= nn_facty )  ijjs = 2
+!!$                mjs2_crs(jpj_crs-jj+1)   = ijjs
+!!$                mje2_crs(jpj_crs-jj+1)   = ijje
+!!$            ENDDO
+!!$
+!!$         CASE DEFAULT
+!!$            WRITE(numout,*) 'crs_init. Only jperio = 0, 1, 3, 4, 5, 6 supported' 
+!!$ 
+!!$         END SELECT
 
       CASE (1 )
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/CRS/crslbclnk.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/CRS/crslbclnk.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/CRS/crslbclnk.F90	(revision 14644)
@@ -50,5 +50,5 @@
       IF( .NOT.ll_grid_crs )   CALL dom_grid_crs   ! Save the parent grid information  & Switch to coarse grid domain
       !
-      CALL lbc_lnk( 'crslbclnk', pt3d1, cd_type1, psgn, kfillmode, pfillval )
+      CALL lbc_lnk( 'crslbclnk', pt3d1, cd_type1, psgn, kfillmode = kfillmode, pfillval = pfillval )
       !
       IF( .NOT.ll_grid_crs )   CALL dom_grid_glo   ! Return to parent grid domain
@@ -80,5 +80,5 @@
       IF( .NOT.ll_grid_crs )   CALL dom_grid_crs   ! Save the parent grid information  & Switch to coarse grid domain
       !
-      CALL lbc_lnk( 'crslbclnk', pt2d, cd_type, psgn, kfillmode, pfillval )
+      CALL lbc_lnk( 'crslbclnk', pt2d, cd_type, psgn, kfillmode = kfillmode, pfillval = pfillval )
       !
       IF( .NOT.ll_grid_crs )   CALL dom_grid_glo   ! Return to parent grid domain
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diacfl.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diacfl.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diacfl.F90	(revision 14644)
@@ -61,8 +61,8 @@
       IF( ln_timing )   CALL timing_start('dia_cfl')
       !
-      llmsk(   1:Nis1,:,:) = .FALSE.                                              ! exclude halos from the checked region
-      llmsk(Nie1: jpi,:,:) = .FALSE.
-      llmsk(:,   1:Njs1,:) = .FALSE.
-      llmsk(:,Nje1: jpj,:) = .FALSE.
+      llmsk(     1:nn_hls,:,:) = .FALSE.   ! exclude halos from the checked region
+      llmsk(Nie0+1:   jpi,:,:) = .FALSE.
+      llmsk(:,     1:nn_hls,:) = .FALSE.
+      llmsk(:,Nje0+1:   jpj,:) = .FALSE.
       !
       DO_3D( 0, 0, 0, 0, 1, jpk )      ! calculate Courant numbers
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diadetide.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diadetide.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diadetide.F90	(revision 14644)
@@ -13,5 +13,5 @@
    USE tide_mod
    USE par_kind
-#if defined key_iomput
+#if defined key_xios
    USE xios
 #endif
@@ -48,5 +48,5 @@
 
       lk_diadetide = .FALSE.
-#if defined key_iomput
+#if defined key_xios
       ! Enquire detiding activation state (test for presence of detiding-related
       ! weights field and output file group)
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diamlr.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diamlr.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diamlr.F90	(revision 14644)
@@ -14,7 +14,7 @@
    USE in_out_manager , ONLY :   lwp, numout, ln_timing
    USE iom            , ONLY :   iom_put, iom_use, iom_update_file_name
-   USE timing         , ONLY :   timing_start, timing_stop
+   USE timing         , ONLY :   timing_start, timing_stop	
    USE par_kind
-#if defined key_iomput
+#if defined key_xios
    USE xios
 #endif
@@ -65,5 +65,5 @@
       !!
       !!----------------------------------------------------------------------
-#if defined key_iomput
+#if defined key_xios
 
       TYPE(xios_fieldgroup)                       ::   slxhdl_fldgrp
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diaptr.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diaptr.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diaptr.F90	(revision 14644)
@@ -382,5 +382,5 @@
             zts(:,:,:,:) = 0._wp
 
-            DO_3D( 1, 0, 1, 1, 1, jpkm1 )
+            DO_3D( 1, 1, 1, 0, 1, jpkm1 )
                zvfc = e1v(ji,jj) * e3v(ji,jj,jk,Kmm)
                zmask(ji,jj,jk)      = vmask(ji,jj,jk)      * zvfc
@@ -437,5 +437,5 @@
             zts(:,:,:,:) = 0._wp
 
-            DO_3D( 1, 0, 1, 1, 1, jpkm1 )
+            DO_3D( 1, 1, 1, 0, 1, jpkm1 )
                zvfc = e1v(ji,jj) * e3v(ji,jj,jk,Kmm)
                zts(ji,jj,jk,jp_tem) = (ts(ji,jj,jk,jp_tem,Kmm)+ts(ji,jj+1,jk,jp_tem,Kmm)) * 0.5 * zvfc  !Tracers averaged onto V grid
@@ -578,5 +578,5 @@
       REAL(wp), DIMENSION(A1Dj(nn_hls),nbasin), INTENT(in)            ::  pva    !
       INTEGER                                               ::  jj
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       INTEGER, DIMENSION(1)           ::  ish1d
       INTEGER, DIMENSION(2)           ::  ish2d
@@ -588,5 +588,5 @@
       END DO
 
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       IF( ntile == 0 .OR. ntile == nijtile ) THEN
          ish1d(1) = jpj*nbasin
@@ -614,5 +614,5 @@
       REAL(wp), DIMENSION(A1Dj(nn_hls),jpk,nbasin), INTENT(in)        ::  pva    !
       INTEGER                                               ::  jj, jk
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       INTEGER, DIMENSION(1)              ::  ish1d
       INTEGER, DIMENSION(3)              ::  ish3d
@@ -626,5 +626,5 @@
       END DO
 
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       IF( ntile == 0 .OR. ntile == nijtile ) THEN
          ish1d(1) = jpj*jpk*nbasin
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diawri.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diawri.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/DIA/diawri.F90	(revision 14644)
@@ -70,5 +70,5 @@
    PUBLIC   dia_wri_state
    PUBLIC   dia_wri_alloc           ! Called by nemogcm module
-#if ! defined key_iomput   
+#if ! defined key_xios   
    PUBLIC   dia_wri_alloc_abl       ! Called by sbcabl  module (if ln_abl = .true.)
 #endif
@@ -94,7 +94,7 @@
 CONTAINS
 
-#if defined key_iomput
+#if defined key_xios
    !!----------------------------------------------------------------------
-   !!   'key_iomput'                                        use IOM library
+   !!   'key_xios'                                        use IOM library
    !!----------------------------------------------------------------------
    INTEGER FUNCTION dia_wri_alloc()
@@ -250,18 +250,21 @@
       ENDIF
 
-      IF( ln_zad_Aimp ) ww = ww + wi               ! Recombine explicit and implicit parts of vertical velocity for diagnostic output
-      CALL iom_put( "woce", ww )                   ! vertical velocity
+      !                                            ! vertical velocity
+      IF( ln_zad_Aimp ) THEN   ;   CALL iom_put( "woce", ww + wi )   ! explicit plus implicit parts
+      ELSE                     ;   CALL iom_put( "woce", ww )
+      ENDIF
 
       IF( iom_use('w_masstr') .OR. iom_use('w_masstr2') ) THEN   ! vertical mass transport & its square value
-         ! Caution: in the VVL case, it only correponds to the baroclinic mass transport.
-         z2d(:,:) = rho0 * e1e2t(:,:)
+         !                     ! Caution: in the VVL case, it only correponds to the baroclinic mass transport.
          DO jk = 1, jpk
-            z3d(:,:,jk) = ww(:,:,jk) * z2d(:,:)
+            IF( ln_zad_Aimp ) THEN
+               z3d(:,:,jk) = rho0 * e1e2t(:,:) * ( ww(:,:,jk) + wi(:,:,jk) )
+            ELSE
+               z3d(:,:,jk) = rho0 * e1e2t(:,:) * ww(:,:,jk)
+            ENDIF
          END DO
          CALL iom_put( "w_masstr" , z3d )  
-         IF( iom_use('w_masstr2') )   CALL iom_put( "w_masstr2", z3d(:,:,:) * z3d(:,:,:) )
-      ENDIF
-      !
-      IF( ln_zad_Aimp ) ww = ww - wi               ! Remove implicit part of vertical velocity that was added for diagnostic output
+         IF( iom_use('w_masstr2') )   CALL iom_put( "w_masstr2", z3d * z3d )
+      ENDIF
 
       CALL iom_put( "avt" , avt )                  ! T vert. eddy diff. coef.
